/**
   This ast2infix() method takes an Abstract Syntax Tree
   for the language of arithmetic expressions and converts
   it into a string that contains the infix version of the
   expression.

   This version of ast2infix() does not print out the
   minimun number of needed parentheses.
*/

public class AST2infix
{
   /**
      This ast2infix() method is essentially
      an in-order traversal of the tree.
   */
   public static String ast2infix(Tree tree)
   {
      String result = "";

      if ( tree.degree() == 0 )  // constant term
      {
         result += tree.getElement();
      }
      else if ( tree.degree() == 1 )  // unary operator
      {
         result += tree.getElement() + "(" + ast2infix( tree.getSubTree(0) ) + ")";
      }
      else if ( tree.degree() == 2 )  // binary operator
      {
         result += "(" + ast2infix( tree.getSubTree(0) );

         result += " " + tree.getElement() + " ";

         result += ast2infix( tree.getSubTree(1) ) + ")";
      }
      else  // operators with 3 or more operands
      {
         result += "(" + ast2infix( tree.getSubTree(0) );

         for (int i = 1; i < tree.degree(); i++)
         {
            result += " " + tree.getElement() + " ";

            result += ast2infix( tree.getSubTree(i) );
         }
         result += ")";
      }

      return result;
   }//ast2infix()

}//AST2infix