/**
   This ast2infix() method takes a BTree for the language
   of arithmetic expressions and converts it into a string
   that contains the infix version of the expression.

   This version of ast2infix() does not print out the
   minimun number of needed parentheses.
*/

public class AST2infix
{
   /**
      This ast2infix() method is essentially
      an in-order traversal of the binary tree.
   */
   public static String ast2infix(BTree tree)
   {
      String result = "";

      if ( 0 == tree.degree() )  // constant term (stops the recursion)
      {
         result += tree.getElement();
      }
      else // binary operator
      {
         result += "(" + ast2infix( tree.getLeftTree() );
         result += " " + tree.getElement() + " ";
         result += ast2infix( tree.getRightTree() ) + ")";
      }

      return result;
   }//ast2infix()

}//AST2infix